# Perfect Python Package

[![PyPI](https://img.shields.io/pypi/v/perf-py-pkg.svg)][pypi_]
[![Status](https://img.shields.io/pypi/status/perf-py-pkg.svg)][status]
[![Python Version](https://img.shields.io/pypi/pyversions/perf-py-pkg)][python version]
[![License](https://img.shields.io/pypi/l/perf-py-pkg)][license]

[![Read the documentation at https://perf-py-pkg.readthedocs.io/](https://img.shields.io/readthedocs/perf-py-pkg/latest.svg?label=Read%20the%20Docs)][read the docs]
[![Tests](https://github.com/kulsuri/perf-py-pkg/workflows/Tests/badge.svg)][tests]
[![Codecov](https://codecov.io/gh/kulsuri/perf-py-pkg/branch/main/graph/badge.svg)][codecov]

[![pre-commit](https://img.shields.io/badge/pre--commit-enabled-brightgreen?logo=pre-commit&logoColor=white)][pre-commit]
[![Black](https://img.shields.io/badge/code%20style-black-000000.svg)][black]

[pypi_]: https://pypi.org/project/perf-py-pkg/
[status]: https://pypi.org/project/perf-py-pkg/
[python version]: https://pypi.org/project/perf-py-pkg
[read the docs]: https://perf-py-pkg.readthedocs.io/
[tests]: https://github.com/kulsuri/perf-py-pkg/actions?workflow=Tests
[codecov]: https://app.codecov.io/gh/kulsuri/perf-py-pkg
[pre-commit]: https://github.com/pre-commit/pre-commit
[black]: https://github.com/psf/black

## Features

- creates a Python package;
- Poetry for dependency management;
- GitHub repository to host the code;
- pre-commit hooks to make sure we only make commits that meet certain criteria;
- added a license to the project;
- configured Poetry to allow uploading to PyPI and a test version of PyPI;
- tested uploading the package to a test version of PyPI;
- added Scriv to help us with changelog management and generation;
- contributer guide;
- code of conduct documentation;
- sphinx documentation;
- readme project description;
- tagged and published a release of our project;
- implemented unit tests;
- automated testing and linting with nox;
- checked code coverage;
- CI/CD with GitHub actions to run linting and testing;
- integrated with Codecov to get coverage reports in our pull requests;
- created a GitHub action to publish our package to PyPI automatically;
- badges to the README file;

update with these:

- Packaging and dependency management with Poetry
  Test automation with Nox
  Linting with pre-commit and Flake8
  Continuous integration with GitHub Actions
  Documentation with Sphinx, MyST, and Read the Docs using the furo theme
  Automated uploads to PyPI and TestPyPI
  Automated release notes with Release Drafter
  Automated dependency updates with Dependabot
  Code formatting with Black and Prettier
  Import sorting with isort
  Testing with pytest
  Code coverage with Coverage.py
  Coverage reporting with Codecov
  Command-line interface with Click
  Static type-checking with mypy
  Runtime type-checking with Typeguard
  Automated Python syntax upgrades with pyupgrade
  Security audit with Bandit and Safety
  Check documentation examples with xdoctest
  Generate API documentation with autodoc and napoleon
  Generate command-line reference with sphinx-click
  Manage project labels with GitHub Labeler

## Requirements

- TODO

## Installation

You can install _Perfect Python Package_ via [pip] from [PyPI]:

```console
$ pip install perf-py-pkg
```

## Usage

Please see the [Command-line Reference] for details.

## Contributing

Contributions are very welcome.
To learn more, see the [Contributor Guide].

## License

Distributed under the terms of the [MIT license][license],
_Perfect Python Package_ is free and open source software.

## Issues

If you encounter any problems,
please [file an issue] along with a detailed description.

## Credits

This project was generated from [@cjolowicz]'s [Hypermodern Python Cookiecutter] template.

[@cjolowicz]: https://github.com/cjolowicz
[pypi]: https://pypi.org/
[hypermodern python cookiecutter]: https://github.com/cjolowicz/cookiecutter-hypermodern-python
[file an issue]: https://github.com/kulsuri/perf-py-pkg/issues
[pip]: https://pip.pypa.io/

<!-- github-only -->

[license]: https://github.com/kulsuri/perf-py-pkg/blob/main/LICENSE
[contributor guide]: https://github.com/kulsuri/perf-py-pkg/blob/main/CONTRIBUTING.md
[command-line reference]: https://perf-py-pkg.readthedocs.io/en/latest/usage.html
